org.apache.lucene.analysis.compound

## Class CompoundWordTokenFilterBase

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.TokenFilter
      - - org.apache.lucene.analysis.compound.CompoundWordTokenFilterBase

- Direct Known Subclasses:
    DictionaryCompoundWordTokenFilter, HyphenationCompoundWordTokenFilter

      public abstract class CompoundWordTokenFilterBase
      extends org.apache.lucene.analysis.TokenFilter

  Base class for decomposition token filters.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `org.apache.lucene.util.AttributeSource.AttributeFactory, org.apache.lucene.util.AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_MAX_SUBWORD_SIZE` The default for maximal length of subwords that get propagated to the output of this filter
    `static int` | `DEFAULT_MIN_SUBWORD_SIZE` The default for minimal length of subwords that get propagated to the output of this filter
    `static int` | `DEFAULT_MIN_WORD_SIZE` The default for minimal word length that gets decomposed
    `protected org.apache.lucene.analysis.CharArraySet` | `dictionary`
    `protected int` | `maxSubwordSize`
    `protected int` | `minSubwordSize`
    `protected int` | `minWordSize`
    `protected boolean` | `onlyLongestMatch`
    `protected java.util.LinkedList` | `tokens`

    - ### Fields inherited from class org.apache.lucene.analysis.TokenFilter

      `input`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.util.Set dictionary)`
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.util.Set dictionary, boolean onlyLongestMatch)`
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.util.Set dictionary, int minWordSize, int minSubwordSize, int maxSubwordSize, boolean onlyLongestMatch)`
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.lang.String[] dictionary)`
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.lang.String[] dictionary, boolean onlyLongestMatch)`
    `protected` | `CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input, java.lang.String[] dictionary, int minWordSize, int minSubwordSize, int maxSubwordSize, boolean onlyLongestMatch)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods Deprecated Methods
    Modifier and Type | Method and Description
    --- | ---
    `protected static void` | `addAllLowerCase(java.util.Set target, java.util.Collection col)`
    `protected org.apache.lucene.analysis.Token` | `createToken(int offset, int length, org.apache.lucene.analysis.Token prototype)`
    `protected void` | `decompose(org.apache.lucene.analysis.Token token)`
    `protected abstract void` | `decomposeInternal(org.apache.lucene.analysis.Token token)`
    `boolean` | `incrementToken()`
    `static java.util.Set` | `makeDictionary(java.lang.String[] dictionary)` Create a set of words from an array The resulting Set does case insensitive matching TODO We should look for a faster dictionary lookup approach.
    `protected static char[]` | `makeLowerCaseCopy(char[] buffer)`
    `org.apache.lucene.analysis.Token` | `next()` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `org.apache.lucene.analysis.Token` | `next(org.apache.lucene.analysis.Token reusableToken)` Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
    `void` | `reset()`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenFilter

      `close, end`

    - ### Methods inherited from class org.apache.lucene.analysis.TokenStream

      `getOnlyUseNewAPI, setOnlyUseNewAPI`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_MIN_WORD_SIZE

          public static final int DEFAULT_MIN_WORD_SIZE

      The default for minimal word length that gets decomposed
      See Also:
        Constant Field Values

    - #### DEFAULT_MIN_SUBWORD_SIZE

          public static final int DEFAULT_MIN_SUBWORD_SIZE

      The default for minimal length of subwords that get propagated to the output of this filter
      See Also:
        Constant Field Values

    - #### DEFAULT_MAX_SUBWORD_SIZE

          public static final int DEFAULT_MAX_SUBWORD_SIZE

      The default for maximal length of subwords that get propagated to the output of this filter
      See Also:
        Constant Field Values

    - #### dictionary

          protected final org.apache.lucene.analysis.CharArraySet dictionary

    - #### tokens

          protected final java.util.LinkedList tokens

    - #### minWordSize

          protected final int minWordSize

    - #### minSubwordSize

          protected final int minSubwordSize

    - #### maxSubwordSize

          protected final int maxSubwordSize

    - #### onlyLongestMatch

          protected final boolean onlyLongestMatch

  - ### Constructor Detail

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.lang.String[] dictionary,
                                                int minWordSize,
                                                int minSubwordSize,
                                                int maxSubwordSize,
                                                boolean onlyLongestMatch)

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.lang.String[] dictionary,
                                                boolean onlyLongestMatch)

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.util.Set dictionary,
                                                boolean onlyLongestMatch)

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.lang.String[] dictionary)

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.util.Set dictionary)

    - #### CompoundWordTokenFilterBase

          protected CompoundWordTokenFilterBase(org.apache.lucene.analysis.TokenStream input,
                                                java.util.Set dictionary,
                                                int minWordSize,
                                                int minSubwordSize,
                                                int maxSubwordSize,
                                                boolean onlyLongestMatch)

  - ### Method Detail

    - #### makeDictionary

          public static final java.util.Set makeDictionary(java.lang.String[] dictionary)

      Create a set of words from an array The resulting Set does case insensitive matching TODO We should look for a faster dictionary lookup approach.
      Parameters:
        `dictionary` -
      Returns:
        `Set` of lowercased terms

    - #### incrementToken

          public final boolean incrementToken()
                                       throws java.io.IOException

      Overrides:
        `incrementToken` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### next

          public final org.apache.lucene.analysis.Token next(org.apache.lucene.analysis.Token reusableToken)
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### next

          public final org.apache.lucene.analysis.Token next()
                                                      throws java.io.IOException

      Deprecated. Will be removed in Lucene 3.0. This method is final, as it should not be overridden. Delegates to the backwards compatibility layer.
      Overrides:
        `next` in class `org.apache.lucene.analysis.TokenStream`
      Throws:
        `java.io.IOException`

    - #### addAllLowerCase

          protected static final void addAllLowerCase(java.util.Set target,
                                                      java.util.Collection col)

    - #### makeLowerCaseCopy

          protected static char[] makeLowerCaseCopy(char[] buffer)

    - #### createToken

          protected final org.apache.lucene.analysis.Token createToken(int offset,
                                                                       int length,
                                                                       org.apache.lucene.analysis.Token prototype)

    - #### decompose

          protected void decompose(org.apache.lucene.analysis.Token token)

    - #### decomposeInternal

          protected abstract void decomposeInternal(org.apache.lucene.analysis.Token token)

    - #### reset

          public void reset()
                     throws java.io.IOException

      Overrides:
        `reset` in class `org.apache.lucene.analysis.TokenFilter`
      Throws:
        `java.io.IOException`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.